Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/leapfrog_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/leapfrog_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/leapfrog_p.F	(revision 1114)
@@ -9,5 +9,5 @@
 #define CPP_IOIPSL
 
-      SUBROUTINE leapfrog_p(ucov,vcov,teta,ps,masse,phis,nq,q,clesphy0,
+      SUBROUTINE leapfrog_p(ucov,vcov,teta,ps,masse,phis,q,clesphy0,
      &                    time_0)
 
@@ -21,4 +21,5 @@
        USE vampir
        USE timer_filtre, ONLY : print_filtre_timer
+       USE infotrac
 
       IMPLICIT NONE
@@ -69,13 +70,6 @@
 #include "com_io_dyn.h"
 #include "iniprint.h"
-
-c#include "tracstoke.h"
-
 #include "academic.h"
-!#include "clesphys.h"
-#include "advtrac.h"
       
-      integer nq
-
       INTEGER         longcles
       PARAMETER     ( longcles = 20 )
@@ -88,5 +82,5 @@
       REAL :: vcov(ip1jm,llm),ucov(ip1jmp1,llm) ! vents covariants
       REAL :: teta(ip1jmp1,llm)                 ! temperature potentielle 
-      REAL :: q(ip1jmp1,llm,nqmx)               ! champs advectes
+      REAL :: q(ip1jmp1,llm,nqtot)              ! champs advectes
       REAL :: ps(ip1jmp1)                       ! pression  au sol
       REAL,SAVE :: p (ip1jmp1,llmp1  )               ! pression aux interfac.des couches
@@ -109,5 +103,6 @@
 c   tendances dynamiques
       REAL,SAVE :: dv(ip1jm,llm),du(ip1jmp1,llm)
-      REAL,SAVE :: dteta(ip1jmp1,llm),dq(ip1jmp1,llm,nqmx),dp(ip1jmp1)
+      REAL,SAVE :: dteta(ip1jmp1,llm),dp(ip1jmp1)
+      REAL,DIMENSION(:,:,:), ALLOCATABLE, SAVE :: dq
 
 c   tendances de la dissipation
@@ -118,5 +113,6 @@
       REAL,SAVE :: dvfi(ip1jm,llm),dufi(ip1jmp1,llm)
       REAL,SAVE :: dtetafi(ip1jmp1,llm)
-      REAL,SAVE :: dqfi(ip1jmp1,llm,nqmx),dpfi(ip1jmp1)
+      REAL,SAVE :: dpfi(ip1jmp1)
+      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: dqfi
 
 c   variables pour le fichier histoire
@@ -186,5 +182,6 @@
       type(Request) :: Request_physic
       REAL,SAVE :: dvfi_tmp(iip1,llm),dufi_tmp(iip1,llm)
-      REAL,SAVE :: dtetafi_tmp(iip1,llm),dqfi_tmp(iip1,llm,nqmx)
+      REAL,SAVE :: dtetafi_tmp(iip1,llm)
+      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: dqfi_tmp
       REAL,SAVE :: dpfi_tmp(iip1)
 
@@ -195,4 +192,5 @@
       INTEGER :: var_time
       LOGICAL :: ok_start_timer=.FALSE.
+      LOGICAL, SAVE :: firstcall=.TRUE.
 
 c$OMP MASTER
@@ -208,5 +206,5 @@
       itaufin   = nday*day_step
       itaufinp1 = itaufin +1
-
+      modname="leapfrog_p"
 
       itau = 0
@@ -217,4 +215,15 @@
           iday = iday+1
          ENDIF
+
+c Allocate variables depending on dynamic variable nqtot
+c$OMP MASTER
+         IF (firstcall) THEN
+            firstcall=.FALSE.
+            ALLOCATE(dq(ip1jmp1,llm,nqtot))
+            ALLOCATE(dqfi(ip1jmp1,llm,nqtot))
+            ALLOCATE(dqfi_tmp(iip1,llm,nqtot))
+         END IF
+c$OMP END MASTER      
+c$OMP BARRIER
 
 c-----------------------------------------------------------------------
@@ -455,5 +464,5 @@
      &                                jj_Nb_caldyn,0,0,TestRequest)
  
-        do j=1,nqmx
+        do j=1,nqtot
          call Register_SwapFieldHallo(q(1,1,j),q(1,1,j),ip1jmp1,llm,
      &                                jj_nb_caldyn,0,0,TestRequest)
@@ -490,5 +499,5 @@
        call Register_Hallo(p,ip1jmp1,llmp1,1,1,1,1,TestRequest)
        
-c       do j=1,nqmx
+c       do j=1,nqtot
 c         call Register_Hallo(q(1,1,j),ip1jmp1,llm,1,1,1,1,
 c     *                       TestRequest)
@@ -516,5 +525,5 @@
         call WriteField_p('pkf',reshape(pkf,(/iip1,jmp1,llm/)))
         call WriteField_p('phis',reshape(phis,(/iip1,jmp1/)))
-        do j=1,nqmx
+        do j=1,nqtot
           call WriteField_p('q'//trim(int2str(j)),
      .                reshape(q(:,:,j),(/iip1,jmp1,llm/)))
@@ -608,4 +617,5 @@
 c$OMP BARRIER
 !       CALL FTRACE_REGION_BEGIN("integrd")
+
        CALL integrd_p ( 2,vcovm1,ucovm1,tetam1,psm1,massem1 ,
      $         dv,du,dteta,dq,dp,vcov,ucov,teta,q,ps,masse,phis ,
@@ -625,5 +635,5 @@
 c
 c      call WriteField_p('ps',reshape(ps,(/iip1,jmp1/)))
-c      do j=1,nqmx
+c      do j=1,nqtot
 c        call WriteField_p('q'//trim(int2str(j)),
 c     .                reshape(q(:,:,j),(/iip1,jmp1,llm/)))
@@ -669,5 +679,4 @@
 
 c$OMP BARRIER
-
          CALL exner_hyb_p(  ip1jmp1, ps, p,alpha,beta,pks, pk, pkf )
 c$OMP BARRIER
@@ -725,5 +734,5 @@
         
 c        call SetDistrib(jj_nb_vanleer)
-        do j=1,nqmx
+        do j=1,nqtot
  
           call Register_SwapFieldHallo(q(1,1,j),q(1,1,j),ip1jmp1,llm,
@@ -756,5 +765,5 @@
 cc$OMP BARRIER
 !        CALL FTRACE_REGION_BEGIN("calfis")
-        CALL calfis_p( nq, lafin ,rdayvrai,time  ,
+        CALL calfis_p(lafin ,rdayvrai,time  ,
      $               ucov,vcov,teta,q,masse,ps,p,pk,phis,phi ,
      $               du,dv,dteta,dq,
@@ -799,5 +808,5 @@
      *                      1,0,0,1,Request_physic)
 
-        do j=1,nqmx
+        do j=1,nqtot
           call Register_Hallo(dqfi(1,1,j),ip1jmp1,llm,
      *                        1,0,0,1,Request_physic)
@@ -842,5 +851,5 @@
 cc$OMP END MASTER
 c      
-c      do j=1,nqmx
+c      do j=1,nqtot
 c        call WriteField_p('dqfi'//trim(int2str(j)),
 c     .                reshape(dqfi(:,:,j),(/iip1,jmp1,llm/)))
@@ -853,5 +862,5 @@
          ENDIF
        
-          CALL addfi_p( nqmx, dtphys, leapf, forward   ,
+          CALL addfi_p( dtphys, leapf, forward   ,
      $                  ucov, vcov, teta , q   ,ps ,
      $                 dufi, dvfi, dtetafi , dqfi ,dpfi  )
@@ -889,5 +898,5 @@
      *                               jj_Nb_caldyn,Request_physic)
 
-        do j=1,nqmx
+        do j=1,nqtot
         
           call Register_SwapField(q(1,1,j),q(1,1,j),ip1jmp1,llm,
@@ -954,6 +963,4 @@
         CALL pression_p ( ip1jmp1, ap, bp, ps, p                  )
 c$OMP BARRIER
-
-
         CALL exner_hyb_p( ip1jmp1, ps, p,alpha,beta, pks, pk, pkf )
 c$OMP BARRIER
@@ -1291,5 +1298,5 @@
 c$OMP BARRIER
 c$OMP MASTER
-              CALL writedynav_p(histaveid, nqmx, itau,vcov ,
+              CALL writedynav_p(histaveid, itau,vcov ,
      ,                          ucov,teta,pk,phi,q,masse,ps,phis)
 c$OMP END MASTER
@@ -1339,5 +1346,5 @@
 #ifdef CPP_IOIPSL
  
-        CALL writehist_p(histid,histvid, nqmx,itau,vcov, 
+        CALL writehist_p(histid,histvid, itau,vcov, 
      s                       ucov,teta,phi,q,masse,ps,phis)
 
@@ -1354,5 +1361,5 @@
 
        CALL dynredem1_p("restart.nc",0.0,
-     ,                     vcov,ucov,teta,q,nqmx,masse,ps)
+     ,                     vcov,ucov,teta,q,masse,ps)
 c#endif
 
@@ -1437,5 +1444,5 @@
 c$OMP BARRIER
 c$OMP MASTER
-              CALL writedynav_p(histaveid, nqmx, itau,vcov ,
+              CALL writedynav_p(histaveid, itau,vcov ,
      ,                          ucov,teta,pk,phi,q,masse,ps,phis)
                call bilan_dyn_p (2,dtvr*iperiod,dtvr*day_step*periodav,
@@ -1480,5 +1487,5 @@
 #ifdef CPP_IOIPSL
 
-       CALL writehist_p( histid, histvid, nqmx, itau,vcov , 
+       CALL writehist_p( histid, histvid, itau,vcov , 
      ,                           ucov,teta,phi,q,masse,ps,phis)
 c#else
@@ -1487,5 +1494,5 @@
 c      call Gather_Field(teta,ip1jmp1,llm,0)
 c      call Gather_Field(ps,ip1jmp1,1,0)
-c      do iq=1,nqmx
+c      do iq=1,nqtot
 c        call Gather_Field(q(1,1,iq),ip1jmp1,llm,0)
 c      enddo
@@ -1502,5 +1509,5 @@
 c$OMP MASTER
                    CALL dynredem1_p("restart.nc",0.0,
-     .                               vcov,ucov,teta,q,nqmx,masse,ps)
+     .                               vcov,ucov,teta,q,masse,ps)
 c$OMP END MASTER
                  ENDIF
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/test_period.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/test_period.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/test_period.F	(revision 1114)
@@ -3,4 +3,5 @@
 !
       SUBROUTINE test_period ( ucov, vcov, teta, q, p, phis )
+      USE infotrac, ONLY : nqtot
 c
 c     Auteur : P. Le Van  
@@ -17,5 +18,5 @@
 c
       REAL ucov(ip1jmp1,llm), vcov(ip1jm,llm), teta(ip1jmp1,llm) ,
-     ,      q(ip1jmp1,llm,nqmx), p(ip1jmp1,llmp1), phis(ip1jmp1)
+     ,      q(ip1jmp1,llm,nqtot), p(ip1jmp1,llmp1), phis(ip1jmp1)
 c
 c   .....  Variables  locales  .....
@@ -68,5 +69,5 @@
       
 c
-      DO nq =1, nqmx
+      DO nq =1, nqtot
         DO l =1, llm
           DO ij = 1, ip1jmp1, iip1
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/vlspltgen_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/vlspltgen_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/vlspltgen_p.F	(revision 1114)
@@ -26,4 +26,5 @@
       USE Write_Field_p
       USE VAMPIR
+      USE infotrac, ONLY : nqtot
       IMPLICIT NONE
 
@@ -38,8 +39,8 @@
 c   Arguments:
 c   ----------
-      INTEGER iadv(nqmx)
+      INTEGER iadv(nqtot)
       REAL masse(ip1jmp1,llm),pente_max
       REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm)
-      REAL q(ip1jmp1,llm,nqmx)
+      REAL q(ip1jmp1,llm,nqtot)
       REAL w(ip1jmp1,llm),pdt
       REAL p(ip1jmp1,llmp1),teta(ip1jmp1,llm),pk(ip1jmp1,llm)
@@ -51,9 +52,9 @@
 c
       REAL,SAVE :: qsat(ip1jmp1,llm)
-      REAL,SAVE :: zm(ip1jmp1,llm,nqmx)
+      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: zm
       REAL,SAVE :: mu(ip1jmp1,llm)
       REAL,SAVE :: mv(ip1jm,llm)
       REAL,SAVE :: mw(ip1jmp1,llm+1)
-      REAL,SAVE :: zq(ip1jmp1,llm,nqmx)
+      REAL,DIMENSION(:,:,:),ALLOCATABLE,SAVE :: zq
       REAL zzpbar, zzw
 
@@ -67,4 +68,6 @@
       REAL tempe(ip1jmp1)
       INTEGER ijb,ije,iq
+      LOGICAL, SAVE :: firstcall=.TRUE.
+
       type(request) :: MyRequest1
       type(request) :: MyRequest2
@@ -83,4 +86,11 @@
         retv = 0.6077667
         rtt  = 273.16
+
+c Allocate variables depending on dynamic variable nqtot
+         IF (firstcall) THEN
+            firstcall=.FALSE.
+            ALLOCATE(zm(ip1jmp1,llm,nqtot))
+            ALLOCATE(zq(ip1jmp1,llm,nqtot))
+         END IF
 
 c-- Calcul de Qsat en chaque point
@@ -164,5 +174,5 @@
        ije=ij_end
 
-      DO iq=1,nqmx
+      DO iq=1,nqtot
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK) 
         DO l=1,llm
@@ -175,5 +185,5 @@
 
 c$OMP BARRIER           
-      DO iq=1,nqmx
+      DO iq=1,nqtot
 
         if(iadv(iq) == 0) then
@@ -245,5 +255,5 @@
 c$OMP END MASTER       
 c$OMP BARRIER
-      do iq=1,nqmx
+      do iq=1,nqtot
 
         if(iadv(iq) == 0) then
@@ -285,5 +295,5 @@
 c$OMP BARRIER
  
-      do iq=1,nqmx
+      do iq=1,nqtot
 
         if(iadv(iq) == 0) then
@@ -308,5 +318,5 @@
 
 
-      do iq=1,nqmx
+      do iq=1,nqtot
 
         if(iadv(iq) == 0) then 
@@ -359,5 +369,5 @@
 
 c$OMP BARRIER
-      do iq=1,nqmx
+      do iq=1,nqtot
 
         if(iadv(iq) == 0) then
@@ -398,5 +408,5 @@
 
 
-      do iq=1,nqmx
+      do iq=1,nqtot
 
         if(iadv(iq) == 0) then
@@ -420,5 +430,5 @@
        enddo
 
-      do iq=1,nqmx
+      do iq=1,nqtot
 
         if(iadv(iq) == 0) then 
@@ -450,5 +460,5 @@
 
 
-      DO iq=1,nqmx
+      DO iq=1,nqtot
 
 c$OMP DO SCHEDULE(STATIC,OMP_CHUNK)          
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/write_grads_dyn.h
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/write_grads_dyn.h	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/write_grads_dyn.h	(revision 1114)
@@ -24,5 +24,5 @@
       string10='teta'
       CALL wrgrads(1,llm,teta,string10,string10)
-      do iq=1,nqmx
+      do iq=1,nqtot
          string10='q'
          write(string10(2:2),'(i1)') iq
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/writedynav_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/writedynav_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/writedynav_p.F	(revision 1114)
@@ -2,5 +2,5 @@
 ! $Header$
 !
-      subroutine writedynav_p( histid, nq, time, vcov, 
+      subroutine writedynav_p( histid, time, vcov, 
      ,                          ucov,teta,ppk,phi,q,masse,ps,phis)
 
@@ -8,4 +8,5 @@
       USE parallel
       USE misc_mod
+      USE infotrac
       implicit none
 
@@ -17,5 +18,4 @@
 C   Entree:
 C      histid: ID du fichier histoire
-C      nqmx: nombre maxi de traceurs
 C      time: temps de l'ecriture
 C      vcov: vents v covariants
@@ -47,5 +47,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 C
@@ -53,10 +52,10 @@
 C
 
-      INTEGER histid, nq
+      INTEGER histid
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
       REAL teta(ip1jmp1,llm),phi(ip1jmp1,llm),ppk(ip1jmp1,llm)                  
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
       REAL phis(ip1jmp1)                  
-      REAL q(ip1jmp1,llm,nq)
+      REAL q(ip1jmp1,llm,nqtot)
       integer time
 
@@ -139,5 +138,5 @@
 C  Traceurs
 C
-        DO iq=1,nq
+        DO iq=1,nqtot
           call histwrite(histid, ttext(iq), itau_w, q(ijb:ije,:,iq), 
      .                   iip1*jjn*llm, ndex3d)
Index: LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/writehist_p.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/writehist_p.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/dyn3dpar/writehist_p.F	(revision 1114)
@@ -2,5 +2,5 @@
 ! $Header$
 !
-      subroutine writehist_p( histid, histvid, nq, time, vcov, 
+      subroutine writehist_p( histid, histvid, time, vcov, 
      ,                          ucov,teta,phi,q,masse,ps,phis)
 
@@ -8,4 +8,5 @@
       USE parallel
       USE misc_mod
+      USE infotrac
       implicit none
 
@@ -18,5 +19,4 @@
 C      histid: ID du fichier histoire
 C      histvid:ID du fichier histoire pour les vents V (appele a disparaitre)
-C      nqmx: nombre maxi de traceurs
 C      time: temps de l'ecriture
 C      vcov: vents v covariants
@@ -48,5 +48,4 @@
 #include "description.h"
 #include "serre.h"
-#include "advtrac.h"
 
 C
@@ -54,10 +53,10 @@
 C
 
-      INTEGER histid, nq, histvid
+      INTEGER histid, histvid
       REAL vcov(ip1jm,llm),ucov(ip1jmp1,llm) 
       REAL teta(ip1jmp1,llm),phi(ip1jmp1,llm)                   
       REAL ps(ip1jmp1),masse(ip1jmp1,llm)                   
       REAL phis(ip1jmp1)                  
-      REAL q(ip1jmp1,llm,nq)
+      REAL q(ip1jmp1,llm,nqtot)
       integer time
 
@@ -119,5 +118,5 @@
 C  Traceurs
 C
-        DO iq=1,nq
+        DO iq=1,nqtot
           call histwrite(histid, ttext(iq), itau_w, q(ijb:ije,:,iq), 
      .                   iip1*jjn*llm, ndexu)
Index: LMDZ4/branches/LMDZ4-dev/libf/grid/dimension/makdim
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/grid/dimension/makdim	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/grid/dimension/makdim	(revision 1114)
@@ -1,8 +1,6 @@
-nqmx=$1
-shift
 for i in $* ; do
    list=$list.$i
 done
-fichdim=dimensions${list}.t${nqmx}
+fichdim=dimensions${list}
 
 if [ ! -f $fichdim ] ; then
@@ -53,5 +51,4 @@
 !   dimensions.h contient les dimensions du modele
 !   ndm est tel que iim=2**ndm
-!   nqmx est la dimension de la variable traceur q
 !-----------------------------------------------------------------------
 
@@ -59,7 +56,4 @@
 
       PARAMETER (iim= $im,jjm=$jm,llm=$lm,ndm=$ndm)
-
-      integer nqmx
-      parameter (nqmx=$nqmx)
 
 !-----------------------------------------------------------------------
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/concvl.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/concvl.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/concvl.F	(revision 1114)
@@ -25,4 +25,5 @@
 c
       USE dimphy
+      USE infotrac, ONLY : nbtr
       IMPLICIT none
 c======================================================================
@@ -67,8 +68,4 @@
 c
 #include "dimensions.h"
-cccccc#include "dimphy.h"
-c
-      integer NTRAC
-      PARAMETER (NTRAC=nqmx-2)
 c
        INTEGER iflag_con,iflag_clos
@@ -77,5 +74,5 @@
        REAL t(klon,klev),q(klon,klev),u(klon,klev),v(klon,klev)
        REAL t_wake(klon,klev),q_wake(klon,klev)
-       REAL tra(klon,klev,ntrac)
+       REAL tra(klon,klev,nbtr)
        INTEGER ntra
        REAL work1(klon,klev),work2(klon,klev),ptop2(klon)
@@ -85,5 +82,5 @@
        REAL d_t(klon,klev),d_q(klon,klev),d_u(klon,klev),d_v(klon,klev)
        REAL dd_t(klon,klev),dd_q(klon,klev)
-       REAL d_tra(klon,klev,ntrac)
+       REAL d_tra(klon,klev,nbtr)
        REAL rain(klon),snow(klon)
 c
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/conema3.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/conema3.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/conema3.F	(revision 1114)
@@ -10,4 +10,5 @@
 
       USE dimphy
+      USE infotrac, ONLY : nbtr
       IMPLICIT none
 c======================================================================
@@ -55,10 +56,8 @@
 c
 #include "dimensions.h"
-cym#include "dimphy.h"
 #include "conema3.h"
       INTEGER i, l,m,itra
-      INTEGER ntra,ntrac !number of tracers; if no tracer transport
+      INTEGER ntra       ! if no tracer transport
                          ! is needed, set ntra = 1 (or 0)
-      PARAMETER (ntrac=nqmx-2)
       REAL dtime
 c
@@ -97,5 +96,5 @@
       REAL,ALLOCATABLE,SAVE :: em_qs(:) 
 c$OMP THREADPRIVATE(em_qs)  
-cym      REAL em_u(klev), em_v(klev), em_tra(klev,ntrac)
+cym      REAL em_u(klev), em_v(klev), em_tra(klev,nbtr)
       REAL,ALLOCATABLE,SAVE :: em_u(:),em_v(:),em_tra(:,:)
 c$OMP THREADPRIVATE(em_u,em_v,em_tra)      
@@ -111,5 +110,5 @@
       REAL,ALLOCATABLE,SAVE :: em_d_t(:),em_d_q(:)
 c$OMP THREADPRIVATE(em_d_t,em_d_q)
-cym      REAL em_d_u(klev), em_d_v(klev), em_d_tra(klev,ntrac)
+cym      REAL em_d_u(klev), em_d_v(klev), em_d_tra(klev,nbtr)
       REAL,ALLOCATABLE,SAVE ::em_d_u(:),em_d_v(:),em_d_tra(:,:)
 c$OMP THREADPRIVATE(em_d_u,em_d_v,em_d_tra)      
@@ -188,9 +187,9 @@
         allocate(em_q(klev))
         allocate(em_qs(klev))
-        allocate(em_u(klev), em_v(klev), em_tra(klev,ntrac))
+        allocate(em_u(klev), em_v(klev), em_tra(klev,nbtr))
         allocate(em_ph(klev+1), em_p(klev))
         allocate(em_work1(klev), em_work2(klev))
         allocate(em_d_t(klev), em_d_q(klev))
-        allocate(em_d_u(klev), em_d_v(klev), em_d_tra(klev,ntrac))
+        allocate(em_d_u(klev), em_d_v(klev), em_d_tra(klev,nbtr))
         allocate(em_upwd(klev), em_dnwd(klev), em_dnwdbis(klev))
         allocate(emmip(klev)) 
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/conemav.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/conemav.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/conemav.F	(revision 1114)
@@ -10,4 +10,5 @@
 c
       USE dimphy
+      USE infotrac, ONLY : nbtr
       IMPLICIT none
 c======================================================================
@@ -44,17 +45,14 @@
 c
 #include "dimensions.h"
-cym#include "dimphy.h"
 c
-      integer NTRAC
-      PARAMETER (NTRAC=nqmx-2)
 c
        REAL dtime, paprs(klon,klev+1),pplay(klon,klev)
        REAL t(klon,klev),q(klon,klev),u(klon,klev),v(klon,klev)
-       REAL tra(klon,klev,ntrac)
+       REAL tra(klon,klev,nbtr)
        INTEGER ntra
        REAL work1(klon,klev),work2(klon,klev)
 c
        REAL d_t(klon,klev),d_q(klon,klev),d_u(klon,klev),d_v(klon,klev)
-       REAL d_tra(klon,klev,ntrac)
+       REAL d_tra(klon,klev,nbtr)
        REAL rain(klon),snow(klon)
 c
@@ -74,6 +72,4 @@
        INTEGER i,k,itra
        REAL qs(klon,klev)
-cym       REAL cbmf(klon)
-cym       SAVE cbmf
        REAL,ALLOCATABLE,SAVE :: cbmf(:)
 c$OMP THREADPRIVATE(cbmf)
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/convect3.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/convect3.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/convect3.F	(revision 1114)
@@ -19,21 +19,23 @@
 c#################################################################
       USE dimphy
+      USE infotrac, ONLY : NBTR
 
 #include "dimensions.h"
-cym#include "dimphy.h"
+      INTEGER NA
       PARAMETER (NA=60)
 
-      integer NTRAC
-      PARAMETER (NTRAC=nqmx-2)
       REAL DELTAC              ! cld
       PARAMETER (DELTAC=0.01)  ! cld
 
       INTEGER NENT(NA)
+      INTEGER ND, NDP1, NL, NTRA, IFLAG, icb, inb
+      REAL DTIME, EPMAX, DELT, PRECIP, CAPE
+      REAL DPLCLDT, DPLCLDR
       REAL T1(ND),R1(ND),RS(ND),U(ND),V(ND),TRA(ND,NTRA)
       REAL P(ND),PH(NDP1)
       REAL FT(ND),FR(ND),FU(ND),FV(ND),FTRA(ND,NTRA)
       REAL SIG(ND),W0(ND)
-      REAL UENT(NA,NA),VENT(NA,NA),TRAENT(NA,NA,NTRAC),TRATM(NA)
-      REAL UP(NA),VP(NA),TRAP(NA,NTRAC)
+      REAL UENT(NA,NA),VENT(NA,NA),TRAENT(NA,NA,NBTR),TRATM(NA)
+      REAL UP(NA),VP(NA),TRAP(NA,NBTR)
       REAL M(NA),MP(NA),MENT(NA,NA),QENT(NA,NA),ELIJ(NA,NA)
       REAL SIJ(NA,NA),TVP(NA),TV(NA),WATER(NA)
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/dimphy.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/dimphy.F90	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/dimphy.F90	(revision 1114)
@@ -5,5 +5,4 @@
   INTEGER,SAVE :: kfdia
   INTEGER,SAVE :: kidia
-  INTEGER,SAVE :: nbtr 
   INTEGER,SAVE :: klev
   INTEGER,SAVE :: klevp1
@@ -17,10 +16,9 @@
 CONTAINS
   
-  SUBROUTINE Init_dimphy(klon0,klev0,nbtr0)
+  SUBROUTINE Init_dimphy(klon0,klev0)
   IMPLICIT NONE
   
     INTEGER, INTENT(in) :: klon0
     INTEGER, INTENT(in) :: klev0
-    INTEGER, INTENT(in) :: nbtr0
     
     klon=klon0
@@ -31,5 +29,4 @@
 !$OMP MASTER 
     klev=klev0
-    nbtr=nbtr0
     klevp1=klev+1
     klevm1=klev-1
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/ini_histrac.h
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/ini_histrac.h	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/ini_histrac.h	(revision 1114)
@@ -23,13 +23,13 @@
      .                iim,jj_nb,nhori, 1,1,1, -99, 32,
      .                "once",  zsto,zout)
-         DO it=1,nqmax
+         DO it=1,nbtr
 C champ 2D
          iq=it+2
          iiq=niadv(iq)
-         CALL histdef(nid_tra, tnom(iq), ttext(iiq), "U/kga",
+         CALL histdef(nid_tra, tname(iiq), ttext(iiq), "U/kga",
      .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
          if (lessivage) THEN
-         CALL histdef(nid_tra, "fl"//tnom(iq),"Flux "//ttext(iiq),
+         CALL histdef(nid_tra, "fl"//tname(iiq),"Flux "//ttext(iiq),
      .              "U/m2/s",iim,jj_nb,nhori, klev,1,klev,nvert, 32,
      .              "ave(X)", zsto,zout)
@@ -37,5 +37,5 @@
 
 c---Ajout Olivia
-         CALL histdef(nid_tra, "d_tr_th_"//tnom(iq),
+         CALL histdef(nid_tra, "d_tr_th_"//tname(iiq),
      .	              "tendance thermique"// ttext(iiq), "?",
      .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
@@ -43,10 +43,10 @@
 c
          if(iflag_con.GE.2) then
-         CALL histdef(nid_tra, "d_tr_cv_"//tnom(iq),
+         CALL histdef(nid_tra, "d_tr_cv_"//tname(iiq),
      .	              "tendance convection"// ttext(iiq), "?",
      .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zsto,zout)
 	     endif !(iflag_con.GE.2) then
-         CALL histdef(nid_tra, "d_tr_cl_"//tnom(iq),
+         CALL histdef(nid_tra, "d_tr_cl_"//tname(iiq),
      .	              "tendance couche limite"// ttext(iiq), "?",
      .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/init_phys_lmdz.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/init_phys_lmdz.F90	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/init_phys_lmdz.F90	(revision 1114)
@@ -2,5 +2,5 @@
 !$Header$
 !
-SUBROUTINE Init_Phys_lmdz(iim,jjp1,llm,nbtr,nb_proc,distrib)
+SUBROUTINE Init_Phys_lmdz(iim,jjp1,llm,nb_proc,distrib)
   USE mod_phys_lmdz_para
   USE mod_grid_phy_lmdz
@@ -11,5 +11,4 @@
     INTEGER,INTENT(in) :: jjp1
     INTEGER,INTENT(in) :: llm
-    INTEGER,INTENT(in) :: nbtr
     INTEGER,INTENT(in) :: nb_proc
     INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
@@ -19,5 +18,5 @@
     CALL Init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
 !$OMP PARALLEL
-    CALL Init_dimphy(klon_omp,nbp_lev,nbtr)
+    CALL Init_dimphy(klon_omp,nbp_lev)
 !$OMP END PARALLEL
  
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/initrrnpb.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/initrrnpb.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/initrrnpb.F	(revision 1114)
@@ -5,4 +5,5 @@
      .                   ,vdeptr,scavtr)
       USE dimphy
+      USE infotrac, ONLY : nbtr
       IMPLICIT none
 c======================================================================
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_local_var_mod.F90	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_local_var_mod.F90	(revision 1114)
@@ -71,4 +71,5 @@
 SUBROUTINE phys_local_var_init
 use dimphy
+use infotrac, ONLY : nbtr
 IMPLICIT NONE
 #include "indicesol.h"
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_mod.F90
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_mod.F90	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_mod.F90	(revision 1114)
@@ -430,5 +430,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
   
-  SUBROUTINE phys_output_open(jjmp1,nqmax,nlevSTD,clevSTD,nbteta, &
+  SUBROUTINE phys_output_open(jjmp1,nlevSTD,clevSTD,nbteta, &
                               ctetaSTD,dtime, presnivs, ok_veget, &
                               ocean, iflag_pbl,ok_mensuel,ok_journe, &
@@ -437,4 +437,5 @@
   USE iophy 
   USE dimphy
+  USE infotrac
   USE ioipsl
   USE mod_phys_lmdz_para
@@ -444,9 +445,8 @@
   include "temps.h"
   include "indicesol.h"
-  include "advtrac.h"
   include "clesphys.h"
   include "thermcell.h"
 
-  integer                               :: jjmp1, nqmax
+  integer                               :: jjmp1
   integer                               :: nbteta, nlevSTD, radpas
   logical                               :: ok_mensuel, ok_journe, ok_hf, ok_instan
@@ -907,6 +907,6 @@
      ENDIF
 
-      if (nqmax>=3) THEN
-!Attention    DO iq=3,nqmax
+      if (nqtot>=3) THEN
+!Attention    DO iq=3,nqtot
     DO iq=3,4  
        iiq=niadv(iq)
@@ -937,5 +937,4 @@
        include "temps.h"
        include "indicesol.h"
-       include "advtrac.h"
        include "clesphys.h"
 
@@ -968,5 +967,4 @@
        include "temps.h"
        include "indicesol.h"
-       include "advtrac.h"
        include "clesphys.h"
 
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h	(revision 1114)
@@ -1192,6 +1192,6 @@
 
 !       IF (o_trac%flag(iff)<=lev_files(iff)) THEN
-         if (nqmax.GE.3) THEN
-!           DO iq=3,nqmax
+         if (nqtot.GE.3) THEN
+!           DO iq=3,nqtot
            DO iq=3,4
        IF (o_trac(iq-2)%flag(iff)<=lev_files(iff)) THEN
Index: LMDZ4/branches/LMDZ4-dev/libf/phylmd/physiq.F
===================================================================
--- LMDZ4/branches/LMDZ4-dev/libf/phylmd/physiq.F	(revision 1113)
+++ LMDZ4/branches/LMDZ4-dev/libf/phylmd/physiq.F	(revision 1114)
@@ -2,5 +2,5 @@
 c#define IO_DEBUG
 
-      SUBROUTINE physiq (nlon,nlev,nqmax,
+      SUBROUTINE physiq (nlon,nlev,
      .            debut,lafin,rjourvrai,gmtime,pdtphys,
      .            paprs,pplay,pphi,pphis,presnivs,clesphy0,
@@ -15,4 +15,5 @@
       USE write_field_phy
       USE dimphy
+      USE infotrac
       USE mod_grid_phy_lmdz
       USE mod_phys_lmdz_para
@@ -50,5 +51,4 @@
 c nlon----input-I-nombre de points horizontaux
 c nlev----input-I-nombre de couches verticales
-c nqmax---input-I-nombre de traceurs (y compris vapeur d'eau) = 1
 c debut---input-L-variable logique indiquant le premier passage
 c lafin---input-L-variable logique indiquant le dernier passage
@@ -87,8 +87,5 @@
 #include "clesphys.h"
 #include "control.h"
-!#include "logic.h"
 #include "temps.h"
-cym#include "comgeomphy.h"
-#include "advtrac.h"
 #include "iniprint.h"
 #include "thermcell.h"
@@ -184,5 +181,4 @@
       INTEGER nlon
       INTEGER nlev
-      INTEGER nqmax
       REAL rjourvrai
       REAL gmtime
@@ -200,5 +196,5 @@
       REAL v(klon,klev)
       REAL t(klon,klev),theta(klon,klev)
-      REAL qx(klon,klev,nqmax)
+      REAL qx(klon,klev,nqtot)
       REAL flxmass_w(klon,klev)
       REAL omega(klon,klev) ! vitesse verticale en Pa/s
@@ -206,5 +202,5 @@
       REAL d_v(klon,klev)
       REAL d_t(klon,klev)
-      REAL d_qx(klon,klev,nqmax)
+      REAL d_qx(klon,klev,nqtot)
       REAL d_ps(klon)
       real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
@@ -1110,7 +1106,7 @@
          write(lunout,*) 'DEBUT DE PHYSIQ !!!!!!!!!!!!!!!!!!!!'
          write(lunout,*)
-     s 'nlon,nlev,nqmax,debut,lafin,rjourvrai,gmtime,pdtphys'
+     s 'nlon,nlev,nqtot,debut,lafin,rjourvrai,gmtime,pdtphys'
          write(lunout,*)
-     s  nlon,nlev,nqmax,debut,lafin,rjourvrai,gmtime,pdtphys 
+     s  nlon,nlev,nqtot,debut,lafin,rjourvrai,gmtime,pdtphys 
 
          write(lunout,*) 'papers, play, phi, u, v, t, omega'
@@ -1170,8 +1166,5 @@
       END IF 
       ok_sync=.TRUE.
-      IF (nqmax .LT. 2) THEN
-         abort_message = 'eaux vapeur et liquide sont indispensables'
-         CALL abort_gcm (modname,abort_message,1)
-      ENDIF
+
       IF (debut) THEN
          CALL suphel ! initialiser constantes et parametres phys.
@@ -1500,5 +1493,5 @@
 
 c$OMP MASTER
-       call phys_output_open(jjmp1,nqmax,nlevSTD,clevSTD,nbteta, 
+       call phys_output_open(jjmp1,nlevSTD,clevSTD,nbteta, 
      &                        ctetaSTD,dtime,presnivs,ok_veget,
      &                        type_ocean,iflag_pbl,ok_mensuel,ok_journe,
@@ -1554,5 +1547,5 @@
      $                   calday,
      $                   klon,
-     $                   nqmax,
+     $                   nqtot,
      $                   pdtphys,
      $                   annee_ref,
@@ -1610,5 +1603,5 @@
       ENDDO
       ENDDO
-      DO iq = 1, nqmax
+      DO iq = 1, nqtot
       DO k = 1, klev
       DO i = 1, klon
@@ -1633,6 +1626,6 @@
       ENDDO
       ENDDO
-      IF (nqmax.GE.3) THEN
-      DO iq = 3, nqmax
+      IF (nqtot.GE.3) THEN
+      DO iq = 3, nqtot
       DO  k = 1, klev
       DO  i = 1, klon
@@ -3163,5 +3156,4 @@
      I                   debut,
      I                   lafin,
-     I                   nqmax-2,
      I                   nlon,
      I                   nlev,
@@ -3386,6 +3378,6 @@
       ENDDO
 c
-      IF (nqmax.GE.3) THEN
-      DO iq = 3, nqmax
+      IF (nqtot.GE.3) THEN
+      DO iq = 3, nqtot
       DO  k = 1, klev
       DO  i = 1, klon
@@ -3421,7 +3413,7 @@
       write(lunout,*) 'FIN DE PHYSIQ !!!!!!!!!!!!!!!!!!!!'
       write(lunout,*)
-     s 'nlon,nlev,nqmax,debut,lafin,rjourvrai,gmtime,pdtphys pct tlos'
+     s 'nlon,nlev,nqtot,debut,lafin,rjourvrai,gmtime,pdtphys pct tlos'
       write(lunout,*)
-     s  nlon,nlev,nqmax,debut,lafin,rjourvrai,gmtime,pdtphys,
+     s  nlon,nlev,nqtot,debut,lafin,rjourvrai,gmtime,pdtphys,
      s  pctsrf(igout,is_ter), pctsrf(igout,is_lic),pctsrf(igout,is_oce),
      s  pctsrf(igout,is_sic)
